/* $Id: script.js 26 2023-04-22 12:07:21Z nishi $ */
const prefix = document.getElementById("swinehub-prefix").value;
const api = location.protocol + "//" + location.host + "/" + prefix + "/v1";
const username = document.getElementById("username");
const password = document.getElementById("password");
const repouser = document.getElementById("repouser");
const reponame = document.getElementById("reponame");
const repos = document.getElementById("repositories");
const svn = document.getElementById("svnprefix");
const rlcommit = document.getElementById("repo-latest-commit");
const lcommit = document.getElementById("latest-commit");
const ownername = document.getElementById("ownername");
const path = document.getElementById("path");
const stitle = document.getElementById("swinehub-title");

function getrepos(){
	if(repos){
		repos.innerHTML = "Connecting to the API ...";
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code != 0){
					repos.innerHTML = "Failed to fetch. Reason: <code>" + result.error + "</code>";
				}else{
					if(result.error){
						repos.innerHTML = "Failed to fetch. Reason: <code>" + result.error + "</code>";
					}else{
						repos.innerHTML  = "<ul>\n";
						for(let i of result.repos){
							repos.innerHTML += "<li><a href=\"" + location.protocol + "//" + location.host + "/" + prefix + "/~" + user + "/" + i + "\">~" + user + "/" + i + "</a></li>\n";
						}
						repos.innerHTML += "</ul>\n";
					}
				}
			}
		};
		xhr.open("POST", api + "/repos", true);
		xhr.send(user);
	}
}
if(rlcommit){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let splitted = this.responseText.split(/\r?\n/);
			let content = splitted.filter((x,i)=>{
				if(i != 0 && i != (splitted.length - 2)) return 1;
				return 0;
			});
			rlcommit.innerHTML = content.join("\n");
		}
	};
	xhr.open("POST", api + "/repo/latest-log", true);
	xhr.send(repouser.value + ":" + reponame.value);
}

if(lcommit){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let splitted = this.responseText.split(/\r?\n/);
			let content = splitted.filter((x,i)=>{
				if(i != 0 && i != (splitted.length - 2)) return 1;
				return 0;
			});
			lcommit.innerHTML = content.join("\n");
		}
	};
	xhr.open("POST", api + "/repo/log", true);
	xhr.send(repouser.value + ":" + reponame.value + ":" + path.value);
}

if(rlcommit || lcommit){
	document.title = stitle.value + " [~" + repouser.value + "/" + reponame.value + "]";
}else if(location.pathname == prefix + "/repos/"){
	document.title = stitle.value + " [Repositories]";
}else if(location.pathname == prefix){
	document.title = stitle.value + " [Home]";
}else if(location.pathname == prefix + "/login/"){
	document.title = stitle.value + " [Login]";
}else if(location.pathname == prefix + "/signup/"){
	document.title = stitle.value + " [Signup]";
}

const ctoken = localStorage.getItem("token");
let user;

function swinehub_create_repo(){
	if(document.getElementById("create-repo").disabled == false){
		const xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
			if(this.readyState == 4){
				let result = JSON.parse(this.responseText);
				if(result.code == 0){
					location = location.protocol + "//" + location.host + "/" + prefix + "/~" + user + "/" + document.getElementById("reponame-input").value;
				}else{
					alert("Error: " + result.error);
				}
			}
		};
		xhr.open("POST", api + "/repo/create", true);
		xhr.send(ctoken + ":" + document.getElementById("reponame-input").value);
	}
}

const valid = new XMLHttpRequest();
valid.onreadystatechange = function(){
	if(this.readyState == 4){
		if(this.status == 200){
			let result = JSON.parse(this.responseText);
			user = result.username;
			document.getElementById("buttons").innerHTML = "<i>You are loginned as <code>" + user + "</code></i><button id=\"logout-button\" onclick=\"swinehub_logout()\">Logout</button>";
			document.getElementById("repos-button").style.display = "inline";
			try{
				document.getElementById("create-repo").disabled = false;
			}catch{}
			getrepos();
		}else{
		}
	}
};
valid.open("POST", api + "/valid", true);
valid.send(ctoken);

function swinehub_login(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				localStorage.setItem("token", result.token);
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/login", true);
	xhr.send(username.value + ":" + password.value);
}

function swinehub_signup(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/signup", true);
	xhr.send(username.value + ":" + password.value);
}

function swinehub_logout(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				localStorage.removeItem("token");
				location = prefix;
			}
		}
	};
	xhr.open("POST", api + "/logout", true);
	xhr.send(localStorage.getItem("token"));
}
